clear all;
close all;

%A = randn(4,4);
%xlswrite('D:\DSD\Blog\Linear Equations\Matlab_codes\A_matrix.xlsx',A);
A = xlsread('D:\DSD\Blog\Linear Equations\Matlab_codes\A_matrix.xlsx');

%x = randn(4,1);
%xlswrite('D:\DSD\Blog\Linear Equations\Matlab_codes\x_vector.xlsx',x);
x = xlsread('D:\DSD\Blog\Linear Equations\Matlab_codes\x_vector.xlsx');

y = A*x; %% Basic Linear equation..........

%%%% Multiplying both the sides of linear equation by A'......
ynew = A'*y;
C = A'*A;
[n,~] = size(C);%%% C is a positive definite matrix........


%%%%%% Solving using Cholesky decomposition...............
% [ L] = L_cho_matrix(C,n );
% C1 = L*L';%% To check factorization is correct or not
% [L_inv] = Mat_Trian_inverse(L');%%% Function to find inverse of upper triangular matrix
% L1 = L*L_inv'; %% To correct inverse
% xhat = L_inv*L_inv'*ynew;
%%%%%% Solving using Cholesky decomposition...............

%%%%%% Solving using Cholesky decomposition...............
[L,D] = low_tri_and_D(n,C);
C1 = L*D*L';%% To check factorization is correct or not
[L_invT] = Mat_Trian_inverse(L');%%% Function to find inverse of upper triangular matrix
L1 = L*L_invT';%% To correct inverse checking
xhat = L_invT*inv(D)*L_invT'*ynew;
%%%%%% Solving using Cholesky decomposition...............